<template>
  <div class="subsections -custom-scroll">
    <div class="subsections-scroll">
      <ul
        class="subsectionsList"
        :class="{ '_tabs-mobile': hasTabsMobile }">
        <template
          v-for="(subsection, index01) in subsections">
          <li
            v-if="subsection.has || hasTabsMobile"
            :key="`tab-${index01}`"
            :class="{ '-active': activeSubsectionName === subsection.name, '-is-mobile': !subsection.has }"
            @click="toggleActiveTab(subsection.name)"
            class="subsectionsList-item">
            <span
              v-if="hasTabsMobile"
              class="icon">
              <img
                v-if="subsection.name === 'origin'"
                svg-inline
                src="~/assets/svg/redesign/mobile-nav-original.svg">
              <img
                v-if="subsection.name === 'analog'"
                svg-inline
                src="~/assets/svg/redesign/mobile-nav-analog.svg">
              <img
                v-if="subsection.name === 'characteristics'"
                svg-inline
                src="~/assets/svg/redesign/mobile-nav-characteristic.svg">
              <img
                v-if="subsection.name === 'applicability'"
                svg-inline
                src="~/assets/svg/redesign/mobile-nav-applicability.svg">
            </span>
            <span class="valueIsDesktop">
              {{ subsection.title }}</span>
            <span
              v-if="hasTabsMobile && subsection.name === 'origin'"
              class="valueIsMobile">{{ subsection.title }}</span>
            <span
              v-if="hasTabsMobile && subsection.name === 'analog'"
              class="valueIsMobile">Аналоги, Заменители</span>
            <span
              v-if="hasTabsMobile && subsection.name === 'characteristics'"
              class="valueIsMobile">Характе&shy;ристики</span>
            <span
              v-if="hasTabsMobile && subsection.name === 'applicability'"
              class="valueIsMobile">Приме&shy;няемость</span>
            <span
              v-if="subsection.count"
              class="counter">{{ subsection.count }}
            </span>
            <img
              v-if="!hasTabsMobile"
              svg-inline
              src="~/assets/svg/redesign/button-arrow-right.svg">
          </li>
        </template>
      </ul>
    </div>
    <div
      v-for="(subsection, index02) in subsections"
      :key="`content-${index02}`"
      :class="{ '-active': activeSubsectionName === subsection.name, '-fixed': hasPositionFixedMobile }"
      class="subsectionContent">
      <button
        v-if="subsection.has && subsection.name !== 'branches' && hasPositionFixedMobile"
        @click="toggleActiveTab('mobile')"
        class="buttonBack">
        <img
          svg-inline
          src="~/assets/svg/redesign/arrow-left-bold.svg">
        {{ buttonBackText }}
      </button>

      <slot
        v-if="subsection.has"
        :name="`content-${subsection.name}`"/>
    </div>
  </div>
</template>

<script>
import isMobileMixin from '~/assets/js/mixins/is-mobile';

export default {
  name: 'Subsections',
  mixins: [isMobileMixin],
  props: {
    subsections: {
      type: Array,
      default() {
        return [];
      },
    },
    active: {
      type: String,
      default: null,
    },
    buttonBackText: {
      type: String,
      default: 'Вернуться',
    },
    hasTabsMobile: {
      type: Boolean,
      default: false,
    },
    hasPositionFixedMobile: {
      type: Boolean,
      default: true,
    },
    feedbackFocus: {
      type: Boolean,
      default: false,
    },
  },
  data() {
    let activeSubsectionName = '';

    if (this.active && !this.feedbackFocus) {
      const activeSubsection = this.subsections.find(sub => sub.name === this.active);
      activeSubsectionName = activeSubsection ? activeSubsection.name : '';
    } else if (this.isMobile() && !this.feedbackFocus) {
      activeSubsectionName = 'mobile';
    } else if (this.isMobile() && this.feedbackFocus) {
      activeSubsectionName = 'feedback';
    } else {
      const activeSubsection = this.subsections.find(sub => sub.has);
      activeSubsectionName = activeSubsection ? activeSubsection.name : '';
    }
    return {
      activeSubsectionName,
    };
  },
  watch: {
    active(newVal, oldVal) {
      if (newVal === 'mobile' && oldVal === 'branches') {
        this.activeSubsectionName = this.active;
      }
    },
  },
  methods: {
    toggleActiveTab(name) {
      this.activeSubsectionName = name;
      this.$emit('change-subsection', this.activeSubsectionName);
    },
  },
};
</script>

<style scoped lang="postcss">
  .subsections {
    display: block;

    .subsectionsList {
      &-item {
        display: inline-flex;
        align-items: center;
        white-space: nowrap;
        transition: color 0.2s var(--transition-easeOutQuad), border-color 0.2s var(--transition-easeOutQuad);

        .counter {
          margin-left: 0.375rem;
        }

        &.-active {
          pointer-events: none;
        }

        &:not(.-active) {
          .counter {
            font-weight: var(--font-weight-regular);
            color: var(--color-main-lightest);
            border: 1px solid var(--color-main-lightest);
            background-color: transparent;
            box-shadow: none;
          }
        }
      }
    }

    .subsectionContent {
      display: none;

      &.-active {
        display: block;
      }
    }

    @media screen and (min-width: 981px) {
      &-scroll {
        display: block;
        background-color: var(--bg-dark);
        border-bottom: 1px solid var(--border-color-main);
      }

      .-is-mobile {
        display: none;
      }

      .subsectionsList {
        display: flex;
        height: 2.375rem;
        padding-top: 0.125rem;

        &-item {
          padding: 0 1.5rem;
          font-size: 0.75rem;
          color: var(--color-main-lightest);
          border-bottom: 0.125rem solid transparent;
          cursor: pointer;

          &.-active {
            color: var(--color-main);
            border-bottom-color: var(--btn-bg);
          }

          .svg, .valueIsMobile {
            display: none;
          }
        }
      }

      .subsectionContent {
        &-feedback {
          padding: 1.5rem 1.25rem;
          .feedbacks {
            width: 70%;
            min-width: 48rem;
          }
        }
        &-original {
          padding: 0.5rem 0 1.5rem;
        }

        &-analog {
          padding: 1.5rem 0;
        }

        &-characteristics {
          padding: 1rem 0 1.5rem;
          max-width: 54%;
        }

        &-applicability {
          padding: 1rem 0 1.5rem;
          max-width: 48rem;

          .abstractTable {
            .thead {
              border: 1px solid var(--border-color-main);
            }
            .tbody {
              height: auto;
            }
          }
        }

        &-options {
          display: flex;
          justify-content: flex-end;
          padding: 1.5rem 0 0;
        }

        .buttonBack {
          display: none;
        }
      }
    }

    @media (min-width: 981px) and (max-width: 1200px) {
      &-scroll {
        max-width: 100%;
        overflow-x: auto;
      }
    }

    @media screen and (max-width: 980px) {
      .subsectionsList:not(._tabs-mobile) {
        display: block;
        .subsectionsList-item {
          display: flex;
          padding: 1.25rem 0 1.25rem 1.25rem;
          font-size: 1.125rem;
          font-weight: var(--font-weight-medium);
          border-bottom: 1px solid var(--border-color-main);

          .counter {
            margin-right: 1rem;
            padding: 0 0.5rem;
            height: 1.125rem;
            line-height: 1.125rem;
            font-size: 0.875rem;
          }

          .svg {
            display: block;
            margin-left: auto;
            margin-right: 1.5rem;
            width: auto;
            height: .75rem;
            fill: var(--color-main-lightest);
          }
        }
      }

      .subsectionsList._tabs-mobile {
        display: flex;
        justify-content: center;
        margin: 0;
        padding: 0 1rem;
        width: 100%;
        border-bottom: 1px solid var(--border-color-light);

        .subsectionsList-item {
          display: inline-flex;
          flex-direction: column;
          align-items: center;
          margin: 0 0 -1px;
          padding: 0 1vw 1rem;
          width: auto;
          font-size: 0.75rem;
          color: var(--color-main-lightest);
          white-space: normal;
          text-align: center;
          border-bottom: 2px solid transparent;
          transition: color .1s var(--transition-easeOutQuad);

          &.-active {
            color: var(--btn-basket-fill);
            border-color: var(--btn-basket-fill);
            .svg {
              fill: var(--btn-basket-fill);
            }
          }

          .counter {
            display: flex;
            margin: 0;
            font: inherit;
            color: inherit;
            background-color: transparent;
            border: none;
            &:before {
              content: '(';
            }
            &:after {
              content: ')';
            }
          }
        }

        .valueIsDesktop {
          display: none;
        }
        .valueIsMobile {
          max-width: 5rem;
        }

        .svg {
          display: block;
          margin-bottom: .5rem;
          fill: var(--border-color-main);
          transition: fill .1s var(--transition-easeOutQuad);
        }

      }

      .subsectionContent {
        background-color: var(--bg-main);

        &.-fixed {
          position: fixed;
          z-index: var(--z-index-over-modal);
          top: 0;
          bottom: 0;
          left: 0;
          width: 100vw;
          min-width: 20rem;
          height: 100vh;
          overflow-y: auto;
        }

        &-feedback {
          padding: 1rem 0 3rem;
          .feedbacks-header {
            padding-top: 2rem;
            padding-bottom: 2rem;
            border-bottom: 1px solid var(--border-color-main);
          }
        }

        &-applicability {
          padding: 0;
          width: 100%;
          .abstractTable {
            .thead {
              border-top: 1px solid var(--border-color-main);
            }
            .tbody {
              height: auto;
            }
          }
        }

        &-characteristics {
          padding: 1.25rem;
        }

        &-options {
          display: flex;
          justify-content: center;
          padding: 1.25rem;
        }

        .heading {
          font-weight: var(--font-weight-medium);

          &._h3 {
            padding-top: 0.5rem;
            font-size: 0.875rem;
          }
        }

        .buttonBack {
          position: sticky;
          position: -webkit-sticky;
          top: 0;
          left: 0;
          z-index: 4;
          display: flex;
          padding: 0 1.25rem;
          align-items: center;
          width: 100%;
          height: 4.5rem;
          font-size: 1.125rem;
          font-weight: var(--font-weight-bold);
          color: var(--color-main-lightest);

          background-color: var(--bg-main);
          border: none;
          outline: none;
          border-bottom: 1px solid var(--border-color-main);

          .svg {
            margin-right: 1.25rem;
            fill: var(--color-main-lightest);
          }
        }
      }
    }
  }
</style>
